package com.huimv.cattle.controller;


import cn.hutool.core.util.ObjectUtil;
import com.alibaba.druid.wall.violation.ErrorCode;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.huimv.cattle.pojo.DataSource;
import com.huimv.cattle.pojo.PreventDetection;
import com.huimv.cattle.pojo.vo.PreventDetectionVo;
import com.huimv.cattle.service.DataSourceService;
import com.huimv.cattle.service.PreventDetectionService;
import com.huimv.cattle.token.TokenSign;
import com.huimv.cattle.utils.FarmCodeUtils;
import com.huimv.common.utils.Result;
import com.huimv.common.utils.ResultCode;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;

/**
 * <p>
 *  前端控制器
 * </p>
 *
 * @author zn
 * @since 2022-12-14
 */
@CrossOrigin
@RestController
@RequestMapping("/v1.0.0/preventDetection")
public class PreventDetectionController {
    @Autowired
    private PreventDetectionService preventDetectionService;
    @Resource
    private DataSourceService dataSourceService;

    @Transactional
    @PostMapping("/savePreventDetection")
    public  Result add(@RequestBody PreventDetectionVo preventDetection, HttpServletRequest request){
        String farmCode = FarmCodeUtils.getFarmCode(preventDetection.getFarmCode(), request);
        List<PreventDetection> preventDetection1 = preventDetection.getPreventDetection();
        for (PreventDetection detection1 : preventDetection1) {
            if (Integer.valueOf(detection1.getAcceptanceNum()) > Integer.valueOf(detection1.getDetectionNum())){
                return new Result(10001,"合格数应小于或等于检测数",false);
            }
        }
        if (!ObjectUtil.isNull(preventDetection1)) {
            for (PreventDetection detection : preventDetection1) {
                Integer count = 0;
                for (PreventDetection preventDetection2 : preventDetection1) {
                    if (preventDetection2.getYear().equals(detection.getYear()) && preventDetection2.getMonth().equals(detection.getMonth())){
                        count++;
                    }
                    if (count > 1){
                        return new Result(10002,"存在重复日期",false);
                    }
                }
            }
        }
        preventDetectionService.remove(new QueryWrapper<PreventDetection>().eq("farm_code",farmCode));
        System.out.println(farmCode);
        for (PreventDetection detection : preventDetection1) {
            detection.setFarmCode(farmCode);
            preventDetectionService.save(detection);
        }
        return new Result(10000,"添加成功",true);
    }
    @PostMapping("/updatePreventDetection")
    public  Result update(@RequestBody PreventDetection preventDetection){
        preventDetectionService.updateById(preventDetection);
        return new Result(10000,"修改成功",true);
    }
    @PostMapping("/deletePreventDetection")
    public  Result delete(@RequestBody Map<String,String> paramMap){
        String ids = paramMap.get("ids");
        String[] split = ids.split(",");
        for (String s : split) {
            preventDetectionService.removeById(s);
        }
        return new Result(10000,"删除成功",true);
    }
    @PostMapping("/getPreventDetection")
    public  Result list(@RequestBody PreventDetection preventDetection,HttpServletRequest request){
        String farmCode = FarmCodeUtils.getFarmCode(preventDetection.getFarmCode(), request);
        List<PreventDetection> list = preventDetectionService.list(new QueryWrapper<PreventDetection>().eq("farm_code",farmCode).orderByDesc("year").orderByDesc("month"));
        if (ObjectUtil.isEmpty(list)){
            return new Result(ResultCode.SUCCESS,new ArrayList<>());
        }
        return new Result(ResultCode.SUCCESS,list);
    }
    @PostMapping("/getPreventDetectionScreen")
    public  Result getPreventDetectionScreen(@RequestBody PreventDetection preventDetection,HttpServletRequest request){
        String farmCode = FarmCodeUtils.getFarmCode(preventDetection.getFarmCode(), request);
        DataSource dataSource = dataSourceService.getDataSourceStatus();
        //镇汇总
        List<PreventDetection> list = new ArrayList<>();
        if (dataSource.getDsStatus() == 1 && dataSource.getViewType() ==2) {
            list = preventDetectionService.getPreventDetectionScreen(farmCode);
        }else if (dataSource.getDsStatus() == 1 && dataSource.getViewType() == 3){
            list = preventDetectionService.getVillagePreventDetectionScreen(farmCode);
        } else {
            list = preventDetectionService.list(new QueryWrapper<PreventDetection>().eq("farm_code",farmCode).orderByDesc("year").orderByDesc("month"));
            if (ObjectUtil.isEmpty(list)){
                return new Result(ResultCode.SUCCESS,new ArrayList<>());
            }
        }
        //县填写
        return new Result(ResultCode.SUCCESS,list);
    }



}

