package com.huimv.cattle.controller;


import com.huimv.cattle.pojo.DataSource;
import com.huimv.cattle.service.DataSourceService;
import com.huimv.cattle.service.SubsidyCountService;
import com.huimv.common.utils.Result;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletRequest;
import java.util.Map;

/**
 * <p>
 *  前端控制器
 * </p>
 *
 * @author zn
 * @since 2022-12-15
 */
@CrossOrigin
@RestController
@RequestMapping("/v1.0.0/subsidyCount")
public class SubsidyCountController {
    @Autowired
    private SubsidyCountService subsidyCountService;
    @Autowired
    private DataSourceService dataSourceService;

    @PostMapping("/getSubsidyCount")
    public Result getSubsidyCount(HttpServletRequest request, @RequestBody Map<String, String> paramsMap){
        return subsidyCountService.getSubsidyCount(request,paramsMap);
    }
    @PostMapping("/getSubsidyCountScreen")
    public Result getSubsidyCountScreen(HttpServletRequest request, @RequestBody Map<String, String> paramsMap){
        DataSource dataSource = dataSourceService.getDataSourceStatus();
        if (dataSource.getDsStatus() == 1 && dataSource.getViewType() == 3){
            return subsidyCountService.getSubsidyCountScreen(request,paramsMap);
        }else {
            return subsidyCountService.getSubsidyCount(request,paramsMap);
        }

    }

    @PostMapping("/saveSubsidyCount")
    public Result saveSubsidyCount(HttpServletRequest request, @RequestBody Map<String, String> paramsMap){
        return subsidyCountService.saveSubsidyCount(request,paramsMap);
    }
}

