package com.huimv.cattle.controller;


import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.huimv.cattle.pojo.DataSource;
import com.huimv.cattle.pojo.SysFarm;
import com.huimv.cattle.service.DataSourceService;
import com.huimv.cattle.service.SysFarmService;
import com.huimv.common.utils.Result;
import com.huimv.common.utils.ResultCode;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;
import javax.servlet.http.HttpServletRequest;
import java.util.Map;

/**
 * <p>
 *  前端控制器
 * </p>
 *
 * @author zn
 * @since 2022-09-26
 */
@CrossOrigin
@RestController
@RequestMapping("/platform/v1.0.0/farm")
public class SysFarmController {
    @Resource
    private SysFarmService sysFarmService;
    @Autowired
    private DataSourceService dataSourceService;

    /**
     * @Method      : initFarm
     * @Description : 初始化牧场
     * @Params      : [request, paramsMap]
     * @Return      : com.huimv.common.utils.Result
     *
     * @Author      : ZhuoNing
     * @Date        : 2022/10/9
     * @Time        : 16:47
     */
    @PostMapping("/initFarm")
    public Result initFarm(HttpServletRequest request, @RequestBody Map<String, String> paramsMap){
        return sysFarmService.initFarmFlow(request,paramsMap);
    }

    @PostMapping("/list")
    public Result listFarm(HttpServletRequest request, @RequestBody Map<String, String> paramsMap){
        DataSource dataSource = dataSourceService.getDataSourceStatus();
        if (dataSource.getDsStatus() == 1 && dataSource.getViewType() == 2){
            return sysFarmService.listTownFarm(request,paramsMap);
        }else if (dataSource.getDsStatus() == 1 && dataSource.getViewType() == 3){
            return sysFarmService.listVillageFarm(request,paramsMap);
        }else {
            return sysFarmService.listFarm(request,paramsMap);
        }
    }

    @PostMapping("/clientList")
    public Result clientList(HttpServletRequest request, @RequestBody Map<String, String> paramsMap){
        return sysFarmService.listVillageFarm(request,paramsMap);
    }

    @PostMapping("newSub")
    public Result newSub(HttpServletRequest request, @RequestBody Map<String, String> paramsMap){
        return sysFarmService.newSub(request,paramsMap);
    }

    @PostMapping("/getAllFarmId")
    public Result getAllFarms(HttpServletRequest request, @RequestBody Map<String, String> paramsMap){
        return sysFarmService.getAllFarmId(request,paramsMap);
    }

    @PostMapping("/new")
    public Result newFarm(HttpServletRequest request, @RequestBody Map<String, String> paramsMap){
        return sysFarmService.newFarm(request,paramsMap);
    }

    @PostMapping("/edit")
    public Result editFarm(HttpServletRequest request, @RequestBody Map<String, String> paramsMap){
        return sysFarmService.editFarm(request,paramsMap);
    }

    @PostMapping("/remove")
    public Result remove(HttpServletRequest request, @RequestBody Map<String, String> paramsMap){
        return sysFarmService.removeFarm(request,paramsMap);
    }

    @PostMapping("/password/reset")
    public Result resetPassword(HttpServletRequest request, @RequestBody Map<String, String> paramsMap){
        return sysFarmService.resetPassword(request,paramsMap);
    }

    @PostMapping("/listAllTownsCount")
    public Result listAllTownsCount(HttpServletRequest request){
        return sysFarmService.listAllTownsCount(request);
    }

    @PostMapping("/listVillage")
    public Result listVillage(){
        return new Result(ResultCode.SUCCESS,sysFarmService.list(new QueryWrapper<SysFarm>().ne("parent_code","0")));
    }
}

