package com.huimv.cattle.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.StringUtils;
import com.huimv.cattle.mapper.SysFarmMapper;
import com.huimv.cattle.mapper.SysRegionCounTownVillMapper;
import com.huimv.cattle.pojo.PreventDetection;
import com.huimv.cattle.mapper.PreventDetectionMapper;
import com.huimv.cattle.pojo.SysFarm;
import com.huimv.cattle.service.PreventDetectionService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;
import java.util.stream.Collectors;

/**
 * <p>
 *  服务实现类
 * </p>
 *
 * @author zn
 * @since 2022-12-14
 */
@Service
public class PreventDetectionServiceImpl extends ServiceImpl<PreventDetectionMapper, PreventDetection> implements PreventDetectionService {

    @Resource
    private PreventDetectionMapper preventDetectionMapper;
    @Autowired
    private SysRegionCounTownVillMapper sysRegionCounTownVillMapper;
    @Resource
    private SysFarmMapper sysFarmMapper;

    @Override
    public List<PreventDetection> getPreventDetectionScreen(String farmCode) {
        List<String> farmCodes =  new ArrayList<>();
        //没传farmId
        if (StringUtils.isBlank(farmCode) ||"0".equals(farmCode)){
            List<SysFarm> sysFarms = sysFarmMapper.selectList(null);
            farmCodes = sysFarms.stream().map(SysFarm::getFarmCode).collect(Collectors.toList());
        }else {
            farmCodes.add(farmCode);
        }
        QueryWrapper<PreventDetection> wrapper = new QueryWrapper<>();
        wrapper.in("farm_code",farmCodes);
        return preventDetectionMapper.getPreventDetectionScreen(wrapper);
    }

    @Override
    public List<PreventDetection> getVillagePreventDetectionScreen(String farmCode) {
        List<String> subCityList = new ArrayList<>();
        if (StringUtils.isBlank(farmCode)){
            farmCode ="0";
        }
        if (StringUtils.isBlank(farmCode) ||"0".equals(farmCode)){
            String[] city = sysRegionCounTownVillMapper.listSub(farmCode).split(",");
            for (String s : city) {
                String[] strings = sysRegionCounTownVillMapper.listSub(s).split(",");
                for (String string : strings) {
                    subCityList.add(string);
                }
            }
            String[] subCity = subCityList.toArray(new String[subCityList.size()]);
            QueryWrapper<PreventDetection> wrapper = new QueryWrapper<>();
            wrapper.in("farm_code",subCity);
            return preventDetectionMapper.getPreventDetectionScreen(wrapper);
        }else {
            String[] city = sysRegionCounTownVillMapper.listSub(farmCode).split(",");
            QueryWrapper<PreventDetection> wrapper = new QueryWrapper<>();
            wrapper.in("farm_code",city);
            return preventDetectionMapper.getPreventDetectionScreen(wrapper);
        }
    }
}
